diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/sixlowpan/examples/example-ping-lr-wpan.cc ns-3.38/src/sixlowpan/examples/example-ping-lr-wpan.cc
--- ns-3.37/src/sixlowpan/examples/example-ping-lr-wpan.cc	2022-11-01 17:37:24.707395800 -0700
+++ ns-3.38/src/sixlowpan/examples/example-ping-lr-wpan.cc	2023-03-16 20:54:23.816869300 -0700
@@ -49,7 +49,7 @@
 
     if (verbose)
     {
-        LogComponentEnable("Ping6Application", LOG_LEVEL_ALL);
+        LogComponentEnable("Ping", LOG_LEVEL_ALL);
         LogComponentEnable("LrWpanMac", LOG_LEVEL_ALL);
         LogComponentEnable("LrWpanPhy", LOG_LEVEL_ALL);
         LogComponentEnable("LrWpanNetDevice", LOG_LEVEL_ALL);
@@ -81,10 +81,9 @@
     // Add and install the LrWpanNetDevice for each node
     NetDeviceContainer lrwpanDevices = lrWpanHelper.Install(nodes);
 
-    // Fake PAN association and short address assignment.
-    // This is needed because the lr-wpan module does not provide (yet)
-    // a full PAN association procedure.
-    lrWpanHelper.AssociateToPan(lrwpanDevices, 1);
+    // Manual PAN association and extended and short address assignment.
+    // Association using the MAC functions can also be used instead of this step.
+    lrWpanHelper.CreateAssociatedPan(lrwpanDevices, 1);
 
     InternetStackHelper internetv6;
     internetv6.Install(nodes);
@@ -107,21 +106,18 @@
                   << deviceInterfaces.GetAddress(1, 1) << std::endl;
     }
 
-    uint32_t packetSize = 10;
+    uint32_t packetSize = 16;
     uint32_t maxPacketCount = 5;
     Time interPacketInterval = Seconds(1.);
-    Ping6Helper ping6;
+    PingHelper ping(deviceInterfaces.GetAddress(1, 1));
 
-    ping6.SetLocal(deviceInterfaces.GetAddress(0, 1));
-    ping6.SetRemote(deviceInterfaces.GetAddress(1, 1));
+    ping.SetAttribute("Count", UintegerValue(maxPacketCount));
+    ping.SetAttribute("Interval", TimeValue(interPacketInterval));
+    ping.SetAttribute("Size", UintegerValue(packetSize));
+    ApplicationContainer apps = ping.Install(nodes.Get(0));
 
-    ping6.SetAttribute("MaxPackets", UintegerValue(maxPacketCount));
-    ping6.SetAttribute("Interval", TimeValue(interPacketInterval));
-    ping6.SetAttribute("PacketSize", UintegerValue(packetSize));
-    ApplicationContainer apps = ping6.Install(nodes.Get(0));
-
-    apps.Start(Seconds(1.0));
-    apps.Stop(Seconds(10.0));
+    apps.Start(Seconds(2.0));
+    apps.Stop(Seconds(20.0));
 
     if (!disableAsciiTrace)
     {
@@ -138,8 +134,10 @@
         Ipv6RoutingHelper::PrintNeighborCacheAllAt(Seconds(9), routingStream);
     }
 
-    Simulator::Stop(Seconds(10));
+    Simulator::Stop(Seconds(20));
 
     Simulator::Run();
     Simulator::Destroy();
+
+    return 0;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/sixlowpan/examples/example-ping-lr-wpan-mesh-under.cc ns-3.38/src/sixlowpan/examples/example-ping-lr-wpan-mesh-under.cc
--- ns-3.37/src/sixlowpan/examples/example-ping-lr-wpan-mesh-under.cc	2022-11-01 17:37:24.707395800 -0700
+++ ns-3.38/src/sixlowpan/examples/example-ping-lr-wpan-mesh-under.cc	2023-03-16 20:54:23.816869300 -0700
@@ -44,7 +44,7 @@
 
     if (verbose)
     {
-        LogComponentEnable("Ping6Application", LOG_LEVEL_ALL);
+        LogComponentEnable("Ping", LOG_LEVEL_ALL);
         LogComponentEnable("LrWpanMac", LOG_LEVEL_ALL);
         LogComponentEnable("LrWpanPhy", LOG_LEVEL_ALL);
         LogComponentEnable("LrWpanNetDevice", LOG_LEVEL_ALL);
@@ -81,10 +81,9 @@
     // Add and install the LrWpanNetDevice for each node
     NetDeviceContainer lrwpanDevices = lrWpanHelper.Install(wsnNodes);
 
-    // Fake PAN association and short address assignment.
-    // This is needed because the lr-wpan module does not provide (yet)
-    // a full PAN association procedure.
-    lrWpanHelper.AssociateToPan(lrwpanDevices, 0);
+    // Manual PAN association and extended and short address assignment.
+    // Association using the MAC functions can also be used instead of this step.
+    lrWpanHelper.CreateAssociatedPan(lrwpanDevices, 0);
 
     InternetStackHelper internetv6;
     internetv6.Install(wsnNodes);
@@ -116,21 +115,18 @@
         dev->SetAttribute("MeshUnderRadius", UintegerValue(10));
     }
 
-    uint32_t packetSize = 10;
+    uint32_t packetSize = 16;
     uint32_t maxPacketCount = 5;
     Time interPacketInterval = Seconds(1.);
-    Ping6Helper ping6;
+    PingHelper ping(wiredDeviceInterfaces.GetAddress(0, 1));
 
-    ping6.SetLocal(wsnDeviceInterfaces.GetAddress(nWsnNodes - 1, 1));
-    ping6.SetRemote(wiredDeviceInterfaces.GetAddress(0, 1));
+    ping.SetAttribute("Count", UintegerValue(maxPacketCount));
+    ping.SetAttribute("Interval", TimeValue(interPacketInterval));
+    ping.SetAttribute("Size", UintegerValue(packetSize));
+    ApplicationContainer apps = ping.Install(wsnNodes.Get(nWsnNodes - 1));
 
-    ping6.SetAttribute("MaxPackets", UintegerValue(maxPacketCount));
-    ping6.SetAttribute("Interval", TimeValue(interPacketInterval));
-    ping6.SetAttribute("PacketSize", UintegerValue(packetSize));
-    ApplicationContainer apps = ping6.Install(wsnNodes.Get(nWsnNodes - 1));
-
-    apps.Start(Seconds(1.0));
-    apps.Stop(Seconds(10.0));
+    apps.Start(Seconds(2.0));
+    apps.Stop(Seconds(20.0));
 
     AsciiTraceHelper ascii;
     lrWpanHelper.EnableAsciiAll(ascii.CreateFileStream("Ping-6LoW-lr-wpan-meshunder-lr-wpan.tr"));
@@ -139,8 +135,10 @@
     csmaHelper.EnableAsciiAll(ascii.CreateFileStream("Ping-6LoW-lr-wpan-meshunder-csma.tr"));
     csmaHelper.EnablePcapAll(std::string("Ping-6LoW-lr-wpan-meshunder-csma"), true);
 
-    Simulator::Stop(Seconds(10));
+    Simulator::Stop(Seconds(20));
 
     Simulator::Run();
     Simulator::Destroy();
+
+    return 0;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/sixlowpan/examples/example-sixlowpan.cc ns-3.38/src/sixlowpan/examples/example-sixlowpan.cc
--- ns-3.37/src/sixlowpan/examples/example-sixlowpan.cc	2022-11-01 17:37:24.707395800 -0700
+++ ns-3.38/src/sixlowpan/examples/example-sixlowpan.cc	2023-03-16 20:54:23.816869300 -0700
@@ -60,7 +60,7 @@
     if (verbose)
     {
         LogComponentEnable("SixLowPanNetDevice", LOG_LEVEL_ALL);
-        LogComponentEnable("Ping6Application", LOG_LEVEL_ALL);
+        LogComponentEnable("Ping", LOG_LEVEL_ALL);
     }
 
     Packet::EnablePrinting();
@@ -107,15 +107,12 @@
     uint32_t packetSize = 200;
     uint32_t maxPacketCount = 50;
     Time interPacketInterval = Seconds(1.);
-    Ping6Helper ping6;
+    PingHelper ping(i2.GetAddress(1, 1));
 
-    ping6.SetLocal(i1.GetAddress(0, 1));
-    ping6.SetRemote(i2.GetAddress(1, 1));
-
-    ping6.SetAttribute("MaxPackets", UintegerValue(maxPacketCount));
-    ping6.SetAttribute("Interval", TimeValue(interPacketInterval));
-    ping6.SetAttribute("PacketSize", UintegerValue(packetSize));
-    ApplicationContainer apps = ping6.Install(net1.Get(0));
+    ping.SetAttribute("Count", UintegerValue(maxPacketCount));
+    ping.SetAttribute("Interval", TimeValue(interPacketInterval));
+    ping.SetAttribute("Size", UintegerValue(packetSize));
+    ApplicationContainer apps = ping.Install(net1.Get(0));
 
     apps.Start(Seconds(5.0));
     apps.Stop(Seconds(15.0));
@@ -129,4 +126,6 @@
     Simulator::Run();
     Simulator::Destroy();
     NS_LOG_INFO("Done.");
+
+    return 0;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/sixlowpan/model/sixlowpan-net-device.cc ns-3.38/src/sixlowpan/model/sixlowpan-net-device.cc
--- ns-3.37/src/sixlowpan/model/sixlowpan-net-device.cc	2022-11-01 17:37:24.707395800 -0700
+++ ns-3.38/src/sixlowpan/model/sixlowpan-net-device.cc	2023-03-16 20:54:23.816869300 -0700
@@ -2356,7 +2356,7 @@
     NS_ASSERT_MSG(l2Mtu > frag1Hdr.GetSerializedSize(),
                   "6LoWPAN: can not fragment, 6LoWPAN headers are bigger than MTU");
 
-    // All the headers are substracted to get remaining units for data
+    // All the headers are subtracted to get remaining units for data
     size = l2Mtu - frag1Hdr.GetSerializedSize() - compressedHeaderSize - extraHdrSize;
     size -= size % 8;
     size += compressedHeaderSize;
@@ -2589,7 +2589,7 @@
 {
     NS_LOG_FUNCTION(this);
 
-    bool ret = m_fragments.size() > 0;
+    bool ret = !m_fragments.empty();
     uint16_t lastEndOffset = 0;
 
     if (ret)
@@ -2877,7 +2877,7 @@
         {
             if (address.HasPrefix(context.contextPrefix))
             {
-                NS_LOG_LOGIC("Fount context "
+                NS_LOG_LOGIC("Found context "
                              << +contextId << " "
                              << Ipv6Address::GetOnes().CombinePrefix(context.contextPrefix)
                              << context.contextPrefix << " matching");
@@ -2920,7 +2920,7 @@
                     addressBytes[9] == contextBytes[5] && addressBytes[10] == contextBytes[6] &&
                     addressBytes[11] == contextBytes[7])
                 {
-                    NS_LOG_LOGIC("Fount context "
+                    NS_LOG_LOGIC("Found context "
                                  << +contextId << " "
                                  << Ipv6Address::GetOnes().CombinePrefix(context.contextPrefix)
                                  << context.contextPrefix << " matching");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/sixlowpan/model/sixlowpan-net-device.h ns-3.38/src/sixlowpan/model/sixlowpan-net-device.h
--- ns-3.37/src/sixlowpan/model/sixlowpan-net-device.h	2022-11-01 17:37:24.707395800 -0700
+++ ns-3.38/src/sixlowpan/model/sixlowpan-net-device.h	2023-03-16 20:54:23.816869300 -0700
@@ -80,7 +80,7 @@
         DROP_FRAGMENT_TIMEOUT = 1,           //!< Fragment timeout exceeded
         DROP_FRAGMENT_BUFFER_FULL,           //!< Fragment buffer size exceeded
         DROP_UNKNOWN_EXTENSION,              //!< Unsupported compression kind
-        DROP_DISALLOWED_COMPRESSION,         //!< HC1 while in IPHC mode or viceversa
+        DROP_DISALLOWED_COMPRESSION,         //!< HC1 while in IPHC mode or vice-versa
         DROP_SATETFUL_DECOMPRESSION_PROBLEM, //!< Decompression failed due to missing or expired
                                              //!< context
     };
@@ -178,7 +178,7 @@
                                        uint32_t ifindex);
 
     /**
-     * TracedCallback signature fo packet drop events
+     * TracedCallback signature for packet drop events
      *
      * \param [in] reason The reason for the drop.
      * \param [in] packet The packet.
@@ -382,7 +382,7 @@
      * \param [in] packet The packet to be compressed.
      * \param [in] src The MAC source address.
      * \param [in] dst The MAC destination address.
-     * \return true if the packet can not be decompressed due to wrong context informations.
+     * \return true if the packet can not be decompressed due to wrong context information.
      */
     bool DecompressLowPanIphc(Ptr<Packet> packet, const Address& src, const Address& dst);
 
@@ -407,7 +407,7 @@
      * \param [in] srcAddress The IPv6 source address.
      * \param [in] dstAddress The IPv6 destination address.
      * \return A std::pair containing the decompressed header type and a flag - true if the packet
-     * can not be decompressed due to wrong context informations.
+     * can not be decompressed due to wrong context information.
      */
     std::pair<uint8_t, bool> DecompressLowPanNhc(Ptr<Packet> packet,
                                                  const Address& src,
@@ -641,7 +641,7 @@
     Ptr<UniformRandomVariable> m_rng; //!< Rng for the fragments tag.
 
     /**
-     * Structure holding the informations for a context (used in compression and decompression)
+     * Structure holding the information for a context (used in compression and decompression)
      */
     struct ContextEntry
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/sixlowpan/test/example-ping-lr-wpan.reflog ns-3.38/src/sixlowpan/test/example-ping-lr-wpan.reflog
--- ns-3.37/src/sixlowpan/test/example-ping-lr-wpan.reflog	2022-11-01 17:37:24.707395800 -0700
+++ ns-3.38/src/sixlowpan/test/example-ping-lr-wpan.reflog	2023-03-16 20:54:23.816869300 -0700
@@ -1,6 +1,16 @@
 Device 0: pseudo-Mac-48 02:00:00:00:00:01, IPv6 Address 2001:2::ff:fe00:1
 Device 1: pseudo-Mac-48 02:00:00:00:00:02, IPv6 Address 2001:2::ff:fe00:2
+PING 2001:2::ff:fe00:2 - 16 bytes of data; 64 bytes including ICMP and IPv6 headers.
+24 bytes from (2001:2::ff:fe00:2): icmp_seq=0 ttl=64 time=21.536 ms
+24 bytes from (2001:2::ff:fe00:2): icmp_seq=1 ttl=64 time=9.312 ms
+24 bytes from (2001:2::ff:fe00:2): icmp_seq=2 ttl=64 time=8.992 ms
+24 bytes from (2001:2::ff:fe00:2): icmp_seq=3 ttl=64 time=9.952 ms
+24 bytes from (2001:2::ff:fe00:2): icmp_seq=4 ttl=64 time=6.752 ms
+
+--- 2001:2::ff:fe00:2 ping statistics ---
+5 packets transmitted, 5 received, 0% packet loss, time 4006ms
+rtt min/avg/max/mdev = 6/10.6/21/5.941 ms
 NDISC Cache of node 0 at time +9s
 2001:2::ff:fe00:2 dev 2 lladdr 00-06-02:00:00:00:00:02 REACHABLE
 NDISC Cache of node 1 at time +9s
-2001:2::ff:fe00:1 dev 2 lladdr 00-06-02:00:00:00:00:01 REACHABLE
+2001:2::ff:fe00:1 dev 2 lladdr 00-06-02:00:00:00:00:01 REACHABLE
\ No newline at end of file
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/sixlowpan/test/sixlowpan-iphc-stateful-test.cc ns-3.38/src/sixlowpan/test/sixlowpan-iphc-stateful-test.cc
--- ns-3.37/src/sixlowpan/test/sixlowpan-iphc-stateful-test.cc	2022-11-01 17:37:24.707395800 -0700
+++ ns-3.38/src/sixlowpan/test/sixlowpan-iphc-stateful-test.cc	2023-03-16 20:54:23.820869200 -0700
@@ -50,12 +50,12 @@
     /**
      * \brief Structure to hold the Rx/Tx packets.
      */
-    typedef struct
+    struct Data
     {
         Ptr<Packet> packet; /**< Packet data */
         Address src;        /**< Source address */
         Address dst;        /**< Destination address */
-    } Data;
+    };
 
     std::vector<Data> m_txPackets; //!< Transmitted packets
     std::vector<Data> m_rxPackets; //!< Received packets
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/spectrum/CMakeLists.txt ns-3.38/src/spectrum/CMakeLists.txt
--- ns-3.37/src/spectrum/CMakeLists.txt	2022-11-01 17:37:24.707395800 -0700
+++ ns-3.38/src/spectrum/CMakeLists.txt	2023-03-16 20:54:23.820869200 -0700
@@ -12,6 +12,7 @@
     model/half-duplex-ideal-phy.cc
     model/matrix-based-channel-model.cc
     model/microwave-oven-spectrum-value-helper.cc
+    model/two-ray-spectrum-propagation-loss-model.cc
     model/multi-model-spectrum-channel.cc
     model/non-communicating-net-device.cc
     model/single-model-spectrum-channel.cc
@@ -50,6 +51,7 @@
     model/half-duplex-ideal-phy.h
     model/matrix-based-channel-model.h
     model/microwave-oven-spectrum-value-helper.h
+    model/two-ray-spectrum-propagation-loss-model.h
     model/multi-model-spectrum-channel.h
     model/non-communicating-net-device.h
     model/single-model-spectrum-channel.h
@@ -82,6 +84,7 @@
   LIBRARIES_TO_LINK ${libpropagation}
                     ${libantenna}
   TEST_SOURCES
+    test/two-ray-splm-test-suite.cc
     test/spectrum-ideal-phy-test.cc
     test/spectrum-interference-test.cc
     test/spectrum-value-test.cc
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/spectrum/examples/adhoc-aloha-ideal-phy-with-microwave-oven.cc ns-3.38/src/spectrum/examples/adhoc-aloha-ideal-phy-with-microwave-oven.cc
--- ns-3.37/src/spectrum/examples/adhoc-aloha-ideal-phy-with-microwave-oven.cc	2022-11-01 17:37:24.711395700 -0700
+++ ns-3.38/src/spectrum/examples/adhoc-aloha-ideal-phy-with-microwave-oven.cc	2023-03-16 20:54:23.824869200 -0700
@@ -299,4 +299,6 @@
     Simulator::Run();
 
     Simulator::Destroy();
+
+    return 0;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/spectrum/examples/CMakeLists.txt ns-3.38/src/spectrum/examples/CMakeLists.txt
--- ns-3.37/src/spectrum/examples/CMakeLists.txt	2022-11-01 17:37:24.711395700 -0700
+++ ns-3.38/src/spectrum/examples/CMakeLists.txt	2023-03-16 20:54:23.824869200 -0700
@@ -2,56 +2,66 @@
   NAME adhoc-aloha-ideal-phy
   SOURCE_FILES adhoc-aloha-ideal-phy.cc
   LIBRARIES_TO_LINK
-    ${libspectrum}
-    ${libmobility}
-    ${libinternet}
     ${libapplications}
+    ${libinternet}
+    ${libmobility}
+    ${libspectrum}
 )
 
 build_lib_example(
   NAME adhoc-aloha-ideal-phy-matrix-propagation-loss-model
   SOURCE_FILES adhoc-aloha-ideal-phy-matrix-propagation-loss-model.cc
   LIBRARIES_TO_LINK
-    ${libspectrum}
-    ${libmobility}
-    ${libinternet}
     ${libapplications}
+    ${libinternet}
+    ${libmobility}
+    ${libspectrum}
 )
 
 build_lib_example(
   NAME adhoc-aloha-ideal-phy-with-microwave-oven
   SOURCE_FILES adhoc-aloha-ideal-phy-with-microwave-oven.cc
   LIBRARIES_TO_LINK
-    ${libspectrum}
-    ${libmobility}
-    ${libinternet}
     ${libapplications}
+    ${libinternet}
+    ${libmobility}
+    ${libspectrum}
 )
 
 build_lib_example(
   NAME tv-trans-example
   SOURCE_FILES tv-trans-example.cc
   LIBRARIES_TO_LINK
-    ${libspectrum}
-    ${libmobility}
     ${libcore}
+    ${libmobility}
+    ${libspectrum}
 )
 
 build_lib_example(
   NAME tv-trans-regional-example
   SOURCE_FILES tv-trans-regional-example.cc
   LIBRARIES_TO_LINK
-    ${libspectrum}
-    ${libmobility}
     ${libcore}
+    ${libmobility}
+    ${libspectrum}
 )
 
 build_lib_example(
   NAME three-gpp-channel-example
   SOURCE_FILES three-gpp-channel-example.cc
   LIBRARIES_TO_LINK
-    ${libspectrum}
+    ${libcore}
+    ${liblte}
     ${libmobility}
+    ${libspectrum}
+)
+
+build_lib_example(
+  NAME three-gpp-two-ray-channel-calibration
+  SOURCE_FILES three-gpp-two-ray-channel-calibration.cc
+  LIBRARIES_TO_LINK
     ${libcore}
     ${liblte}
+    ${libmobility}
+    ${libspectrum}
 )
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/spectrum/examples/three-gpp-channel-example.cc ns-3.38/src/spectrum/examples/three-gpp-channel-example.cc
--- ns-3.37/src/spectrum/examples/three-gpp-channel-example.cc	2022-11-01 17:37:24.711395700 -0700
+++ ns-3.38/src/spectrum/examples/three-gpp-channel-example.cc	2023-03-16 20:54:23.824869200 -0700
@@ -79,8 +79,6 @@
               Ptr<PhasedArrayModel> thisAntenna,
               Ptr<NetDevice> otherDevice)
 {
-    PhasedArrayModel::ComplexVector antennaWeights;
-
     // retrieve the position of the two devices
     Vector aPos = thisDevice->GetNode()->GetObject<MobilityModel>()->GetPosition();
     Vector bPos = otherDevice->GetNode()->GetObject<MobilityModel>()->GetPosition();
@@ -91,20 +89,26 @@
 
     double vAngleRadian = completeAngle.GetInclination(); // the elevation angle
 
-    // retrieve the number of antenna elements
-    int totNoArrayElements = thisAntenna->GetNumberOfElements();
+    // retrieve the number of antenna elements and resize the vector
+    uint64_t totNoArrayElements = thisAntenna->GetNumberOfElements();
+    PhasedArrayModel::ComplexVector antennaWeights(totNoArrayElements);
 
     // the total power is divided equally among the antenna elements
-    double power = 1 / sqrt(totNoArrayElements);
+    double power = 1.0 / sqrt(totNoArrayElements);
 
     // compute the antenna weights
-    for (int ind = 0; ind < totNoArrayElements; ind++)
+    const double sinVAngleRadian = sin(vAngleRadian);
+    const double cosVAngleRadian = cos(vAngleRadian);
+    const double sinHAngleRadian = sin(hAngleRadian);
+    const double cosHAngleRadian = cos(hAngleRadian);
+
+    for (uint64_t ind = 0; ind < totNoArrayElements; ind++)
     {
         Vector loc = thisAntenna->GetElementLocation(ind);
         double phase = -2 * M_PI *
-                       (sin(vAngleRadian) * cos(hAngleRadian) * loc.x +
-                        sin(vAngleRadian) * sin(hAngleRadian) * loc.y + cos(vAngleRadian) * loc.z);
-        antennaWeights.push_back(exp(std::complex<double>(0, phase)) * power);
+                       (sinVAngleRadian * cosHAngleRadian * loc.x +
+                        sinVAngleRadian * sinHAngleRadian * loc.y + cosVAngleRadian * loc.z);
+        antennaWeights[ind] = exp(std::complex<double>(0, phase)) * power;
     }
 
     // store the antenna weights
@@ -173,7 +177,7 @@
     double txPow = 49.0;          // tx power in dBm
     double noiseFigure = 9.0;     // noise figure in dB
     double distance = 10.0;       // distance between tx and rx nodes in meters
-    uint32_t simTime = 10000;     // simulation time in milliseconds
+    uint32_t simTime = 1000;      // simulation time in milliseconds
     uint32_t timeRes = 10;        // time resolution in milliseconds
     std::string scenario = "UMa"; // 3GPP propagation scenario
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/spectrum/examples/three-gpp-two-ray-channel-calibration.cc ns-3.38/src/spectrum/examples/three-gpp-two-ray-channel-calibration.cc
--- ns-3.37/src/spectrum/examples/three-gpp-two-ray-channel-calibration.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.38/src/spectrum/examples/three-gpp-two-ray-channel-calibration.cc	2023-03-16 20:54:23.824869200 -0700
@@ -0,0 +1,269 @@
+/*
+ * Copyright (c) 2022 SIGNET Lab, Department of Information Engineering,
+ * University of Padova
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ */
+
+#include <ns3/command-line.h>
+#include <ns3/core-module.h>
+#include <ns3/double.h>
+#include <ns3/isotropic-antenna-model.h>
+#include <ns3/mobility-helper.h>
+#include <ns3/node-container.h>
+#include <ns3/object-factory.h>
+#include <ns3/pointer.h>
+#include <ns3/string.h>
+#include <ns3/three-gpp-channel-model.h>
+#include <ns3/three-gpp-propagation-loss-model.h>
+#include <ns3/three-gpp-spectrum-propagation-loss-model.h>
+#include <ns3/two-ray-spectrum-propagation-loss-model.h>
+#include <ns3/uinteger.h>
+#include <ns3/uniform-planar-array.h>
+
+NS_LOG_COMPONENT_DEFINE("ThreeGppTwoRayChannelCalibration");
+
+using namespace ns3;
+
+// Calibration results actually show a weak dependence with respect to the carrier frequency
+constexpr double FC_STEP = 5e9;
+
+// 500 MHz, as to provide a fit for the whole frequency range supported by the TR 38.901 model
+constexpr double MIN_FC = 500e6;
+
+// 100 GHz, as to provide a fit for the whole frequency range supported by the TR 38.901 model
+constexpr double MAX_FC = 100e9;
+
+// Results are independent from this
+constexpr double BW = 200e6;
+
+// Results are independent from this, it dictate sonly the resolution of the PSD.
+// This value corresponds to numerology index 2 of the 5G NR specifications
+constexpr double RB_WIDTH = 60e3;
+
+const std::vector<std::string> LOS_CONDITIONS{
+    "LOS",
+    "NLOS",
+};
+
+const std::vector<std::string> THREE_GPP_SCENARIOS{
+    "RMa",
+    "UMa",
+    "UMi-StreetCanyon",
+    "InH-OfficeOpen",
+    "InH-OfficeMixed",
+};
+
+const Ptr<OutputStreamWrapper> g_outStream =
+    Create<OutputStreamWrapper>("two-ray-to-three-gpp-calibration.csv", std::ios::out);
+
+void
+LogEndToEndGain(std::string cond, std::string scen, double fc, long int seed, double gain)
+{
+    *g_outStream->GetStream() << cond << "\t" << scen << "\t" << fc << "\t" << seed << "\t" << gain
+                              << "\n";
+}
+
+double
+ComputePowerSpectralDensityOverallPower(Ptr<const SpectrumValue> psd)
+{
+    return Integral(*psd);
+}
+
+Ptr<SpectrumValue>
+CreateTxPowerSpectralDensity(double fc)
+{
+    uint32_t numRbs = std::floor(BW / RB_WIDTH);
+    double f = fc - (numRbs * RB_WIDTH / 2.0);
+    double powerTx = 0.0;
+
+    Bands rbs;              // A vector representing each resource block
+    std::vector<int> rbsId; // A vector representing the resource block IDs
+    rbsId.reserve(numRbs);
+
+    for (uint32_t numrb = 0; numrb < numRbs; ++numrb)
+    {
+        BandInfo rb;
+        rb.fl = f;
+        f += RB_WIDTH / 2;
+        rb.fc = f;
+        f += RB_WIDTH / 2;
+        rb.fh = f;
+
+        rbs.push_back(rb);
+        rbsId.push_back(numrb);
+    }
+    Ptr<SpectrumModel> model = Create<SpectrumModel>(rbs);
+    Ptr<SpectrumValue> txPsd = Create<SpectrumValue>(model);
+
+    double powerTxW = std::pow(10., (powerTx - 30) / 10);
+    double txPowerDensity = powerTxW / BW;
+
+    for (auto rbId : rbsId)
+    {
+        (*txPsd)[rbId] = txPowerDensity;
+    }
+
+    return txPsd;
+}
+
+double
+ComputeEndToEndGain(std::string cond,
+                    std::string scen,
+                    double fc,
+                    Ptr<Node> a,
+                    Ptr<Node> b,
+                    Ptr<PhasedArrayModel> aArray,
+                    Ptr<PhasedArrayModel> bArray)
+{
+    // Fix the LOS condition
+    Ptr<ChannelConditionModel> channelConditionModel;
+    if (cond == "LOS")
+    {
+        channelConditionModel = CreateObject<AlwaysLosChannelConditionModel>();
+    }
+    else if (cond == "NLOS")
+    {
+        channelConditionModel = CreateObject<NeverLosChannelConditionModel>();
+    }
+    else
+    {
+        NS_ABORT_MSG("Unsupported channel condition");
+    }
+
+    // Create the needed objects. These must be created anew each loop, otherwise the channel is
+    // stored and never re-computed.
+    Ptr<ThreeGppSpectrumPropagationLossModel> threeGppSpectrumLossModel =
+        CreateObject<ThreeGppSpectrumPropagationLossModel>();
+    Ptr<ThreeGppChannelModel> threeGppChannelModel = CreateObject<ThreeGppChannelModel>();
+
+    // Pass the needed pointers between the various spectrum instances
+    threeGppSpectrumLossModel->SetAttribute("ChannelModel", PointerValue(threeGppChannelModel));
+    threeGppChannelModel->SetAttribute("ChannelConditionModel",
+                                       PointerValue(channelConditionModel));
+
+    // Create the TX PSD
+    Ptr<SpectrumValue> txPsd = CreateTxPowerSpectralDensity(fc);
+    double txPower = ComputePowerSpectralDensityOverallPower(txPsd);
+
+    // Create TX signal parameters
+    Ptr<SpectrumSignalParameters> signalParams = Create<SpectrumSignalParameters>();
+    signalParams->psd = txPsd;
+
+    // Set the carrier frequency
+    threeGppChannelModel->SetAttribute("Frequency", DoubleValue(fc));
+
+    // Set the scenario
+    threeGppChannelModel->SetAttribute("Scenario", StringValue(scen));
+
+    // Disable all possible sources of variance apart from the multipath fading
+    threeGppChannelModel->SetAttribute("Blockage", BooleanValue(false));
+
+    // Retrieve the mobility models and the position of the TX and RX nodes
+    Ptr<MobilityModel> aMob = a->GetObject<MobilityModel>();
+    Ptr<MobilityModel> bMob = b->GetObject<MobilityModel>();
+    Vector aPos = aMob->GetPosition();
+    Vector bPos = bMob->GetPosition();
+
+    // Compute the relative azimuth and the elevation angles
+    Angles angleBtoA(bPos, aPos);
+    Angles angleAtoB(aPos, bPos);
+
+    // Create the BF vectors
+    aArray->SetBeamformingVector(aArray->GetBeamformingVector(angleBtoA));
+    bArray->SetBeamformingVector(bArray->GetBeamformingVector(angleAtoB));
+
+    // Compute the received power due to multipath fading
+    auto rxPsd = threeGppSpectrumLossModel->DoCalcRxPowerSpectralDensity(signalParams,
+                                                                         aMob,
+                                                                         bMob,
+                                                                         aArray,
+                                                                         bArray);
+    double rxPower = ComputePowerSpectralDensityOverallPower(rxPsd);
+
+    return rxPower / txPower;
+}
+
+int
+main(int argc, char* argv[])
+{
+    uint32_t numRealizations = 5000; // The number of different channel realizations
+    bool enableOutput = false;       // Whether to log the results of the example
+
+    CommandLine cmd(__FILE__);
+    cmd.AddValue("enableOutput", "Logs the results of the example", enableOutput);
+    cmd.AddValue("numRealizations", "The number of different realizations", numRealizations);
+    cmd.Parse(argc, argv);
+
+    // Log trace structure
+    if (enableOutput)
+    {
+        *g_outStream->GetStream() << "cond\tscen\tfc\tseed\tgain\n";
+    }
+
+    // Aggregate them to the corresponding nodes
+    NodeContainer nodes;
+    nodes.Create(2);
+
+    // Create the mobility models for the TX and RX nodes
+    MobilityHelper mobility;
+    Ptr<ListPositionAllocator> positionAlloc = CreateObject<ListPositionAllocator>();
+    Vector aPos(0.0, 0.0, 0.0);
+    Vector bPos(10.0, 0.0, 0.0);
+    positionAlloc->Add(aPos);
+    positionAlloc->Add(bPos);
+    mobility.SetPositionAllocator(positionAlloc);
+    mobility.SetMobilityModel("ns3::ConstantPositionMobilityModel");
+    mobility.Install(nodes);
+
+    // Create the TX and RX phased arrays
+    Ptr<PhasedArrayModel> aPhasedArray =
+        CreateObjectWithAttributes<UniformPlanarArray>("NumColumns",
+                                                       UintegerValue(1),
+                                                       "NumRows",
+                                                       UintegerValue(1));
+    aPhasedArray->SetAntennaElement(PointerValue(CreateObject<IsotropicAntennaModel>()));
+    Ptr<PhasedArrayModel> bPhasedArray =
+        CreateObjectWithAttributes<UniformPlanarArray>("NumColumns",
+                                                       UintegerValue(1),
+                                                       "NumRows",
+                                                       UintegerValue(1));
+    bPhasedArray->SetAntennaElement(PointerValue(CreateObject<IsotropicAntennaModel>()));
+
+    // Loop over predetermined set of scenarios, LOS conditions and frequencies
+    for (const auto& cond : LOS_CONDITIONS)
+    {
+        for (const auto& scen : THREE_GPP_SCENARIOS)
+        {
+            for (double fc = MIN_FC; fc < MAX_FC; fc += FC_STEP)
+            {
+                for (uint32_t runIdx = 0; runIdx < numRealizations; runIdx++)
+                {
+                    double gain = ComputeEndToEndGain(cond,
+                                                      scen,
+                                                      fc,
+                                                      nodes.Get(0),
+                                                      nodes.Get(1),
+                                                      aPhasedArray,
+                                                      bPhasedArray);
+                    if (enableOutput)
+                    {
+                        LogEndToEndGain(cond, scen, fc, runIdx, gain);
+                    }
+                }
+            }
+        }
+    }
+}
